package models

import "gogs.mikescher.com/BlackForestBytes/goext/rfctime"

type FAPICall struct {
	FAPIRequestID FAPICallID               `json:"id"                bson:"_id,omitempty"`
	Time          rfctime.RFC3339NanoTime  `json:"time"              bson:"time"`
	Success       bool                     `json:"success"           bson:"success"`
	ErrorStr      *string                  `json:"errorStr"          bson:"errorStr"`
	CallingMethod string                   `json:"callingMethod"     bson:"callingMethod"`
	Duration      rfctime.SecondsF64       `json:"duration"          bson:"duration"`
	Request       FAPIRequest              `json:"request"           bson:"request"`
	Response      *FAPIResponse            `json:"response"          bson:"response"`
	Deleted       *rfctime.RFC3339NanoTime `json:"deleted"           bson:"deleted"`
}

type FAPIRequest struct {
	Method      string          `json:"method"            bson:"method"`
	URL         string          `json:"url"               bson:"url"`
	RequestBody string          `json:"requestBody"       bson:"requestBody"`
	Header      []FAPIHeaderDef `json:"header"            bson:"header"`
}

type FAPIResponse struct {
	ResponseStatus int             `json:"responseStatus"     bson:"responseStatus"`
	ResponseBody   *string         `json:"responseBody"       bson:"responseBody"`
	Header         []FAPIHeaderDef `json:"header"             bson:"header"`
	Message        string          `json:"message"            bson:"message"`
}

type FAPIHeaderDef struct {
	Key    string
	Values []string
}
