package models

type SolseitCommunity struct {
	SolseitCommunityID SolseitCommunityID `json:"id"              bson:"_id,omitempty"`
	ReferenceID        int                `json:"referenceID"     bson:"referenceID"`
	Name               string             `json:"name"            bson:"name"`
	Rubrics            []SolseitRubric    `json:"rubrics"         bson:"rubrics"`
}

func (c SolseitCommunity) AllRubrics() []SolseitRubric {
	res := make([]SolseitRubric, 0, len(c.Rubrics))

	var do func(v SolseitRubric)
	do = func(v SolseitRubric) {
		res = append(res, v)
		for _, sub := range v.Rubrics {
			do(sub)
		}
	}

	for _, v := range c.Rubrics {
		do(v)
	}

	return res
}

type SolseitRubric struct {
	ReferenceID int             `json:"referenceID"     bson:"referenceID"`
	Name        string          `json:"name"            bson:"name"`
	Rubrics     []SolseitRubric `json:"rubrics"         bson:"rubrics"`
}
